%{
/*
// THIS FILE IS COPYRIGHT 1994 BY TELENOR RESEARCH, NORWAY
//
//                    ALL RIGHTS RESERVED.
//
// For rights granted to the public see the COPYRIGHT file
*/

/* Programming : Jon Stephenson von Tetzchner */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "book.h"

%}
MIFEND    	"# End".*"Book"
FILENAME	"<FileName".*">"
KILL      	("#"|">"|"<").*
SPACE     	[ \t]+  
MIFSTART  	"<Book".*">".*"#".*"\n"
%%
{MIFSTART}	BookStart();
{MIFEND}	BookEnd();
{FILENAME}	PrintFileName();
"\n"		{/* */}
{KILL}		{/* */}
{SPACE}		{/* */}
%%

FILE *f;
FILE *exists;
char *BOOKFilename;
char *BOOKBasename;       	/* Basename of BOOKFilename (path stripped) */
char *BOOKTitle;
char LastFileName[300];
char *Language;

char *NOFRAMEFILES;		/* Whether to omit translation of
				   FrameMaker-generated files */
char *QUIET;			/* Whether to print error messages
				   only, not status messages */
char *DEBUG;			/* Whether to print debug information
				   messages */

void BookStart()
{
    BOOKFilename = getenv("BOOKFilename");
    BOOKTitle	 = getenv("BOOKTitle");
    Language	 = getenv("DOCUMENTLANGUAGE");
    NOFRAMEFILES = getenv("NOFRAMEFILES");
    QUIET	 = getenv("QUIET");
    DEBUG	 = getenv("DEBUG");

    if (BOOKBasename = strrchr(BOOKFilename, '/'))
	BOOKBasename += 1;
    else
        BOOKBasename = BOOKFilename;

    if (!QUIET)
        fprintf(stderr, "\nbook: Starting translation of file \"%s\"\n",
	        BOOKFilename);

    LastFileName[0] = 0;
}


void BookEnd()
{
    if (!QUIET)
        fprintf(stderr, "book: End of translation\n");
}


/****************************************************************************
  PrintFileName() :
        Input  : Uses yytext
	Output : Prints name of file
 ****************************************************************************/

void PrintFileName()
{
    int i = 0, j = 0;
    char filename[300];
    char basename[300];
    char mifname[300];
    char htmlfilename1[300];
    char call[2000];
    static char *fmfiles[] = {"TOC.doc", "LOF.doc", "LOT.doc", "AIX.doc",
		       "AML.doc", "APL.doc", "IOM.doc", "IX.doc",
		       "LOM.doc", "LOP.doc", "SIX.doc",
                       ".toc", ".lof", ".lot", ".aix", ".aml",
                       ".apl", ".iom", ".ix", ".lom", ".lop", ".six"};
    int num_fmfiles = 22;
    int fmpos;
    char *ptr;
    
    while(yytext[i] && yytext[i] != 96)
	{
	    i++;
	}

    if (yytext[i] == 96)
	{
	    i++;
	    while (yytext[i] && yytext[i] != 39)
		{
		    if (yytext[i] == '<')			
			{
			    if (yytext[i+1] == 'c')
				{	
				    i++;		/* Get by <c\> */
				    i++;
				    i++;
				    i++;
				    while (yytext[i] && yytext[i] != '<' && yytext[i] != 39)
					{
					    filename[j++] = yytext[i++];
					}
				    
				    filename[j++] = 0;

				    if (NOFRAMEFILES)
				        for (fmpos = 0; fmpos < num_fmfiles; fmpos++)
					    if (strstr(filename, fmfiles[fmpos]))
						return;

				    strcpy(basename, filename);
				    sprintf(mifname, "%s.mif", basename);

				    exists = fopen(mifname, "r");
				    if (exists)
				        {
					    close(exists);
					}
				    else
				        {
					    if ((ptr = (char *) strstr(basename, ".doc")) != NULL)
						{
						    *ptr = 0;
						    sprintf(mifname, "%s.mif", basename);
						    exists = fopen(mifname, "r");
						    if (exists)
							{
							    close(exists);
							}
						    else
							{
							    fprintf(stderr,"book: ERROR: MIF version of \"%s\" not found\n", filename);
							    return;
							}
						}
					    else
					        {
						    fprintf(stderr,"book: ERROR: MIF version of \"%s\" not found\n", filename);
						    return;
						}
					}

				    if (!QUIET)
				        fprintf(stderr, "\nbook: Starting translation of document \"%s\" (MIF file \"%s\")\n", filename, mifname);
				    sprintf(call, "rm -f %s.html", basename);
				    system(call);

				    sprintf(call, "-SCRDIR-/f2htranslate %s %s %s %s.html2 %s.tmp.000T %s.tmp.000I %s", QUIET ? "-q" : "", DEBUG ? "-d" : "", basename, basename, BOOKFilename, BOOKFilename, BOOKTitle);
				    system(call);

				    if (LastFileName[0])
					{
					    FILE *lastfile, *thisfile;
					    lastfile = fopen(LastFileName, "a")
;
					    if (lastfile)
						{
						    if (Language && !strcasecmp(Language, "NO"))
						        {
							    fprintf(lastfile, "<P><A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Innhold</A>\n", BOOKBasename);
							    fprintf(lastfile, " <A HREF=\"%s.html\"><IMG SRC=\"fm2html-next.gif\">Neste Kapittel</A>\n", basename);
							}
						    else
						        {
							    fprintf(lastfile, "<P><A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Table of Contents</A>\n", BOOKBasename);
							    fprintf(lastfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-next.gif\">Next Chapter</A>\n", basename);
							}
						    fclose(lastfile);
						}

					    sprintf(htmlfilename1, "%s.html1", basename);
					    thisfile = fopen(htmlfilename1, "w");
					    if (thisfile)
						{
						    if (Language && !strcasecmp(Language, "NO"))
						         {
							     fprintf(thisfile, "<P><A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Innhold</A>\n", BOOKBasename);
							     fprintf(thisfile, "<P><A HREF=\"%s\"><IMG SRC=\"fm2html-previous.gif\">Forrige Kapittel</A>\n", LastFileName);	
/*							     fprintf(thisfile, "<P><A HREF=\"%s\"><IMG SRC=\"fm2html-next.gif\">Neste Kapittel</A>\n", basename); */
							 }
						    else
						         {
							     fprintf(thisfile, "<P><A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Table of Contents</A>\n", BOOKBasename);
							     fprintf(thisfile, "<A HREF=\"%s\"><IMG SRC=\"fm2html-previous.gif\">Previous Chapter</A>\n", LastFileName);
/*							     fprintf(thisfile, "<P><A HREF=\"%s\"><IMG SRC=\"fm2html-next.xbm\">Next Chapter</A>\n", basename); */
							 }
						    fclose(thisfile);

						    /* Add `Forrige` to head of file */
						    sprintf(call, "cat %s.html1 %s.html2 > %s.html",
							    basename, basename, basename);
						    system(call);

						    sprintf(call, "rm -f %s.html1 %s.html2",
							    basename,basename);
						    system(call);
						}
					    else
						{ 
						    fprintf(stderr, "book: ERROR: Could not open file %s for writing\n", htmlfilename1);
						    exit(-1);
						}
					}
				    else
					{
					    FILE *thisfile;
					    sprintf(htmlfilename1, "%s.html1", basename);
					    thisfile = fopen(htmlfilename1, "w");
					    if (thisfile)
						{
						    if (Language && !strcasecmp(Language, "NO"))
							 fprintf(thisfile, "<P><A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Innhold</A>\n", BOOKBasename);
						    else
						        fprintf(thisfile, "<P><A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Table of Contents</A>\n", BOOKBasename);
						    fclose(thisfile);

						    /* Add `Forrige` to head of file */
						    sprintf(call, "cat %s.html1 %s.html2 > %s.html",
							    basename, basename, basename);
						    system(call);

						    sprintf(call, "rm -f %s.html1 %s.html2",
							    basename,basename);
						    system(call);
						}
					    else
						{ 
						    fprintf(stderr, "book: ERROR: Could not open file %s for writing\n",
							    htmlfilename1);
						    exit(-1);
						}
					}
				    sprintf(LastFileName, "%s.html", basename);
				}
			}
		    i++;
		}
	}
}


/*************************************************************************
int main () : added by popular demand to get rid of -lfl...
**************************************************************************/

int main( argc, argv )
      int argc;
      char *argv[];
{
    return yylex();
}


#ifndef yywrap		/* Added as it seems it has been moved to the flex */
int yywrap()		/* library on some systems */
{return 1;}
#endif
